// Criminal.cpp
#include <ostream>

using namespace std;
#include "Jailer.h"
#include "Criminal.h"

int			Criminal::_curDay = 1;
const char* Criminal::_stateNames[] = {
	"   ",
	"",
	"  ",
	"",
	""
};


Criminal::Criminal(Jailer *jailer, ostream *log):
  _jailer(jailer), _log(*log), _y0(0) {}


// A0  
void Criminal::A0(int e)
{
    int y0_old = _y0;
    int _x1, _x2, _x3;

    logBegin();
    switch (_y0) {
        case 0: // 0.    
			_x1 = x1();
			_x2 = x2();
            if (e == 1 &&  _x1 && !_x2) {                    _y0 = 0;}
            else
            if (e == 1 &&  _x1 &&  _x2) {z1_0(); z2();       _y0 = 1;}
            else
			if (e == 1 && !_x1 &&  _x2) {        z2();       _y0 = 1;}
            else
            if (e == 1 && !_x1 && !_x2) {z1_1();             _y0 = 2;}
            else
            if (e == 2)                 {                    _y0 = 3;}
            else
            if (e == 3)                 {                    _y0 = 4;}
        break;

        case 1: // 1. 
			_x1 = x1();
			_x3 = x3();
            if (e == 1 &&  _x1 && !_x3) {z1_0(); z3();       _y0 = 1;}
            else
            if (e == 1 &&  _x1 &&  _x3) {z1_0(); z3(); z4(); _y0 = 1;}
            else
            if (e == 1 && !_x1)         {                    _y0 = 1;}
            else
            if (e == 2)                 {                    _y0 = 3;}
            else
            if (e == 3)                 {                    _y0 = 4;}
        break;

        case 2: // 2.   
            if (e == 1)                 {                    _y0 = 2;}
            else
            if (e == 2)                 {                    _y0 = 3;}
            else
            if (e == 3)                 {                    _y0 = 4;}
        break;

        case 3: // 3. 
        break;

        case 4: // 4. 
        break;

    }

    if (_y0 != y0_old)
        logTrans(y0_old);

	logEnd();
}

void Criminal::e1() {
	logEvent(1, "   ");
	A0(1);
}

void Criminal::e2() {
	logEvent(2, " ");
	A0(2);
}

void Criminal::e3() {
	logEvent(3, " ");
	A0(3);
}

bool Criminal::x1()   
{
    logVar(1, lamp?1:0, " ?");
    return lamp;
}

bool Criminal::x2()   
{
    logVar(2, (_curDay == 1)?1:0,"  -   ?");
    return _curDay == 1;
}

bool Criminal::x3()   
{
    logVar(3, (_counter == 9)?1:0, "   9?");
    return _counter == 9;
}

void Criminal::z1_0() 
{
    logOut(1, 0, " ");
    lamp = false;
}           

void Criminal::z1_1() 
{
    logOut(1, 1, " ");
    lamp = true;
}

void Criminal::z2()   
{
    logOut(2, "  ");
    _counter = 1;
}           

void Criminal::z3()   
{
    logOut(3, "   ");
    _counter ++;
}           

void Criminal::z4()   
{
    logOut(4, "   ,     ");
    _jailer->inform();
}       

void Criminal::logBegin()
{
	_log<<"A0."<<_y0<<" ["<<_stateNames[_y0]<<"]"<<endl;
}

void Criminal::logEnd()
{
	_log<<"A0."<<_y0<<" ["<<_stateNames[_y0]<<"]"<<endl<<endl;
}

void Criminal::logTrans(int y0_old)
{
	_log<<"    "<<"A0."<<_y0<<" ["<<_stateNames[y0_old]<<"] => "
	            <<"A0."<<_y0<<" ["<<_stateNames[_y0]<<"]"<<endl;
}

void Criminal::logVar(int x, int v, char *str)
{
	_log<<"    "<<"x"<<x<<"="<<v<<": ["<<str<<"] - "<<(v?"":"")<<endl;
}

void Criminal::logOut(int z, char *str)
{
	_log<<"    "<<"z"<<z<<":   ["<<str<<"]"<<endl;
}

void Criminal::logOut(int z, int v, char *str)
{
	_log<<"    "<<"z"<<z<<"_"<<v<<": ["<<str<<"]"<<endl;
}

void Criminal::logEvent(int e, char *str)
{
	_log<<"e"<<e<<": ["<<str<<"] - : "<<_curDay<<endl;
}
