// Jailer.cpp
#include <stdlib.h>
#include <time.h>
#include <fstream>
#include <strstream>
using namespace std;
#include "Jailer.h"
#include "Criminal.h"

Jailer::Jailer(int num): 
  _num(num), _informed(false)
{
	srand((unsigned) time(0));
	_crims = new Criminal*[_num];
	_was   = new bool[_num];
	_logs  = new ofstream[_num];
	char buf[256];
	ostrstream str(buf, 255);
	for (int i = 0; i < _num; i++) {
		str.seekp(0);
		str<<"log-"<<i<<".txt"<<'\0';
		_logs[i].open(buf);
		_crims[i] = new Criminal(this, &_logs[i]);
		_was[i]   = false;
	}
}

Jailer::~Jailer() 
{
	for (int i = 0; i < _num; i++)
		delete _crims[i];
	delete[] _crims;
	delete[] _was;
	for (int i = 0; i < _num; i++)
		_logs[i].close();
	delete[] _logs;
}

bool Jailer::check()
{
	for (int i = 0; i < _num; i++) 
		if (!_was[i]) return false;
	return true;
}

void Jailer::inform()
{
	_informed = true;
}

void Jailer::kill() 
{
	for (int i = 0; i < _num; i++)
		_crims[i]->e3();
}

void Jailer::release()
{
	for (int i = 0; i < _num; i++) 
		_crims[i]->e2();
}

int Jailer::getNext() 
{
	return rand() % _num;
}

void Jailer::start() 
{
	int i;
	do {
		i = getNext();
		_crims[i]->e1();
		_was[i] = true;
		Criminal::nextDay();
	} while(! _informed);

	if (check()) release();
	else kill();
}
